Subject: [bug#60521] Dot file layout for ‘home-dotfiles-service’

From: Ludovic Courtès <[email-masked]>
Date: Sat, 10 Feb 2024 11:03:36 +0100

Hi,

paul <[email-masked]> skribis:

> On 2/7/24 23:17, Ludovic Courtès wrote:
>> Hi!
>>
>> Oops, my sincere apologies if I ended up “fixing” something that was in
>> fact intentional, effectively breaking it.
> Don't worry I think there's been a misunderstanding from the beginning
> and I was not able to explain myself . Sh*t happens :)
>> Should we just adjust the manual to match
>> this?
> I think that doing so would defeat the original purpose of supporting
> the de facto standard used by Stow users
>> Or the other way around, at the cost of breaking user config?
> This is really about what one means by breaking, we already received a
> bug report at https://issues.guix.gnu.org/68848 which in my opinion
> indicates that we give some expectations through the manual, which is
> not met by the code (I'm adding Janneke to this thread so that we are
> all aligned and can reach consensus).
>>   Or adding an option to choose between these two layouts?
> This is the best option forward, in my opinion. It is flexible and
> allows for a both for the current simplified layout (without the
> per-application layer of directories typical of Stow) and the Stow
> default one.
>
> If there's consensus my next steps would be:
>
> 1. Apply Janneke's stylistic suggestion at
> https://issues.guix.gnu.org/68857 allowing us to close
> https://issues.guix.gnu.org/68848 and align the code with the manual
>
> 2. Add a layout field to home-dotfiles-configuration that allows for
> the simplified layout described by Ludo' in his last email, something
> like this
>
> $ guix shell tree -- tree -a dot-files/
> dot-files/
> ├── .dico
> ├── .gitconfig
> ├── .gnupg
> │   ├── dirmngr.conf
> │   ├── gpa.conf
> │   ├── gpg.conf
> │   └── .gpg-v21-migrated
> ├── .Xdefaults
> └── .xsession
>
> the default would be the current layout but this would allow for more
> flexibility in layouts in the future.

Thinking about it, either we add a ‘layout’ field (the default should
probably be the same as it is now, to user’s config will still work the
same).

> 3. Possibly add an included-applications (the name is just a proposal)
> to support Sergey's use case of selecting a subset of application
> dotfiles to provision in the user's home

I’m not sure I understand but maybe this part can be addressed later.

Thanks,
Ludo’.